//---- A Silver Fork & Eyeball 


#declare Silver =
texture {  
	0.02  
	ambient 0.3 
	diffuse 0.6 
	colour Gray
	reflection 0.55 
	brilliance 8 
	specular .5
        metallic
}



#declare Slot = quadric { Cylinder_Y scale <15 1 .7> }


#declare Joint =
difference {
	quadric { Cylinder_Z scale <8.5 5 1> translate <-13.5 1 0> }
	quadric { Cylinder_Z scale <8 4.6 1> translate <-13.5 1 0> }
	plane { <1 0 0> -13.5 }
	plane { <1 0 0> -6 inverse }
	plane { <0 0 1> 2 inverse }
	plane { <0 0 1> -2 }
	plane { <0 1 0> 1 }
	quadric { Cylinder_Y scale <3 1 1> translate <-13.5 0 2>  }
	quadric { Cylinder_Y scale <3 1 1> translate <-13.5 0 -2>  }
	quadric { Cylinder_Y scale <5 1 5> translate <-8 0 -6> }
	quadric { Cylinder_Y scale <5 1 5> translate <-8 0 6> }
}

#declare Stem =
difference {
	union {
	intersection { Cube scale <24 .25 1> translate <-37.5 5.75 0> }
	quadric { Sphere scale <1 .5 1> translate <-61.5 5.75 0> }
	quadric { Sphere scale <1 .5 1> translate <-62 5.75 0> }
	intersection { Cube scale <22.5 .25 10> translate <-36 5.75 0> }
	quadric { Sphere scale <3 .5 1.5> translate <-58.5 5.75 1.3> }
	quadric { Sphere scale <3 .5 1.5> translate <-58.5 5.75 -1.3> }
	}
	quadric { Cylinder_Y scale <158 1 43.5> translate <-13.5 0 44.5>  }
	quadric { Cylinder_Y scale <158 1 43.5> translate <-13.5 0 -44.5>  }
}



#declare Fork = 
object {
   union {
	difference {
        quadric { Cylinder_Z scale <15 9.5 1> rotate <0 0 30> translate <6 11.5 0> }
        quadric { Cylinder_Z scale <14.5 9 1> rotate <0 0 30> translate <6 11.5 0> }	
	plane { <0 1 0> 10 inverse }
	plane { <0 0 1> 0 rotate <0 -5 0> translate <0 0 -5> }
	plane { <0 0 1> 0 rotate <0 5 0> translate <0 0 5> inverse }
	plane { <1 0 0> -6 }
	quadric { Slot translate <18 0 -2.2> }
	quadric { Slot translate <18 0 2.2> }
	quadric { Slot translate <18 0 0> }
	quadric { Cylinder_Y scale <5 1 5> translate <-8 0 -6> }
	quadric { Cylinder_Y scale <5 1 5> translate <-8 0 6> }
	}
   difference { Joint }
   difference { Stem }
   }
	texture {
	Silver
	}
		bounded_by {
		intersection { Cube scale <42 7.7 10> translate <-22 5 0> }
		}

}

#declare QA = color red 1 green .8 blue .8 alpha 1

//--- Clearish bloody puddle
#declare Blob1 =
object {
   union {
     quadric { Sphere translate <-.6 .2 0> }
     quadric { Sphere translate <.6 .2 0> }
     quadric { Sphere translate <0 -.6 0> }
   }
   texture {
	bozo
        turbulence .5
	color_map {
	  [0 .5 color Clear color QA]
	  [.5 1 color QA color Clear]
        }
	reflection .3
	ambient .5
        phong .2
        scale <.3 .2 .3>
        refraction .9
    }
   scale <14 18 1.3> 
}

#declare Eye_Fork =
composite {
   object { Fork rotate <0 0 5> scale <2.2 2.2 2.2> }
   object { Eye1 rotate <0 -30 0> rotate <0 0 -30> translate <40 20 0> }
   object { Blob1 rotate <90 0 0> rotate <0 50 0> translate <45 0 0 > }
}










