//---- Room & Counter for Meat Grinder

//------ Tile Counter Top

#declare Tile1Texture =
texture {
	color red .72 green .65 blue .59
	ambient .1
	phong 1
	diffuse .4
	reflection .35
}	


#declare TT1 =
object { 
   union {
	intersection { Disk_X scale <25 2 2> translate <0 -25 0> }
	intersection { Disk_X scale <25 2 2> translate <0 25 0> }
	intersection { Disk_Y scale <2 25 2> translate <25 0 0> }
	intersection { Disk_Y scale <2 25 2> translate <-25 0 0> }
	quadric { Sphere scale <2 2 2> translate <-25 -25 0> }
	quadric { Sphere scale <2 2 2> translate <-25 25 0> }
	quadric { Sphere scale <2 2 2> translate <25 -25 0> }
	quadric { Sphere scale <2 2 2> translate <25 25 0> }
	triangle { <-25 -25 -2> <-25 25 -2> <25 -25 -2> }
	triangle { <-25 25 -2> <25 25 -2> <25 -25 -2> }
    }
  		bounded_by {
		box { UnitBox scale <28 28 4> }
		}
}

#declare Tile1 =
object { TT1 texture { Tile1Texture }  rotate <90 0 0> scale <1.8 1 1.8> }



#declare Tile55 =
composite {
     object { Tile1 translate <450 0 -450> }
     object { Tile1 translate <450 0 -350> }
     object { Tile1 translate <450 0 -250> }
     object { Tile1 translate <450 0 -150> }
     object { Tile1 translate <450 0 -50> }

     object { Tile1 translate <350 0 -450> }
     object { Tile1 translate <350 0 -350> }
     object { Tile1 translate <350 0 -250> }
     object { Tile1 translate <350 0 -150> }
     object { Tile1 translate <350 0 -50> }

     object { Tile1 translate <250 0 -450> }
     object { Tile1 translate <250 0 -350> }
     object { Tile1 translate <250 0 -250> }
     object { Tile1 translate <250 0 -150> }
     object { Tile1 translate <250 0 -50> }





  }



#declare Counter =
object {
  box { UnitBox scale <500 15 500> }
   texture { color Gray10 ambient .1 diffuse .6 }
}



#declare Reflect =
composite {

   //--- front wall
   object {
    plane { <1 0 0> 5000 }
     texture {
	color Black
	ambient .7
	diffuse .3
     }
    }



   //--- world
   object {
    sphere { <0 0 0> 50000 }
     texture {
	color MidnightBlue
	ambient .1
	diffuse .1
     }
    }


   //--- Cieling
   object {
    plane { <0 1 0> 1500 }
     texture {
	color White
	ambient .3
	diffuse .5
     }
    }


} 	 







//--- Out-of-Focus Background
#declare Blur =
object {
  box { UnitBox scale <1000 1000 1> }
    texture {
	image_map { <1 -1 0> gif "blur.gif" interpolate 4 }
	ambient .3
	diffuse .2
	scale <2000 2000 1>
	translate <-1000 -1000 1>
     }
}





